/****************************************************************************************** 
 *	Chili DirectX Framework Version 12.04.24											  *	
 *	Game.cpp																			  *
 *	Copyright 2012 PlanetChili.net														  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "Game.h"

Game::Game( HWND hWnd,const KeyboardServer& kServer,const MouseServer& mServer )
:	gfx( hWnd ),
	audio( hWnd ),
	kbd( kServer ),
	mouse( mServer ),
	cursorX( 375 ),
	cursorY( 275 ),
	cameraX( 0 ),
	cameraY( 0 ),
	SelectorX( 32 ),
	nPlats( NPLATFORMS ),
	keyPressedLastFrame( false ),
	DrawLeft( true ),
	DrawMiddle( false ),
	DrawRight( false ),
	DragAndDrop( false )
	
{
	LoadSprite( &platformL,"Platform\\platformLEnd32x32.bmp",32,32,D3DCOLOR_XRGB( 0,0,0 ) );
	LoadSprite( &platformM,"Platform\\platformMid32x32.bmp",32,32,D3DCOLOR_XRGB( 0,0,0 ) );
	LoadSprite( &platformR,"Platform\\platformREnd32x32.bmp",32,32,D3DCOLOR_XRGB( 0,0,0 ) );
	Lplat.counter = 0;
	Lplat.drag = false;
	Mplat.counter = 0;
	Mplat.drag = false;
	Rplat.counter = 0;
	Rplat.drag = false;
}
Game::~Game()
{
	FreeSprite( &platformL );
	FreeSprite( &platformM );
	FreeSprite( &platformR );
}
void Game::Go()
{
	gfx.BeginFrame();
	ComposeFrame();
	gfx.EndFrame();
	UserFunctions();
	MenuLogic();
	UpdateCamera();
	DrawLeftPlatform();
	DrawMiddlePlatform();
	DrawRightPlatform();
}
void Game::DrawLeftPlatform()
{
	if( Lplat.counter == 1 )
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 0 ] = lastX;
		Lplat.platY[ 0 ] = lastY;
		Lplat.counter++;
	}
	if( Lplat.counter == 3 )
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 1 ] = lastX;
		Lplat.platY[ 1 ] = lastY;
		Lplat.counter++;
	}
	if( Lplat.counter == 5)
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 2 ] = lastX;
		Lplat.platY[ 2 ] = lastY;
		Lplat.counter++;
	}
		if( Lplat.counter == 7)
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 3 ] = lastX;
		Lplat.platY[ 3 ] = lastY;
		Lplat.counter++;
	}
	if( Lplat.counter == 9)
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 4 ] = lastX;
		Lplat.platY[ 4 ] = lastY;
		Lplat.counter++;
	}
	if( Lplat.counter == 11)
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 5 ] = lastX;
		Lplat.platY[ 5 ] = lastY;
		Lplat.counter++;
	}
	if( Lplat.counter == 13)
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 6 ] = lastX;
		Lplat.platY[ 6 ] = lastY;
		Lplat.counter++;
	}
	if( Lplat.counter == 15)
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 7 ] = lastX;
		Lplat.platY[ 7 ] = lastY;
		Lplat.counter++;
	}
	if( Lplat.counter == 17)
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 8 ] = lastX;
		Lplat.platY[ 8 ] = lastY;
		Lplat.counter++;
	}
	if( Lplat.counter == 19)
	{
		lastX = cursorX;
		lastY = cursorY;
		Lplat.platX[ 9 ] = lastX;
		Lplat.platY[ 9 ] = lastY;
		Lplat.counter++;
	}
	
}
void Game::DrawMiddlePlatform()
{
	if( Mplat.counter == 1 )
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 0 ] = lastX;
		Mplat.platY[ 0 ] = lastY;
		Mplat.counter++;
	}
	if( Mplat.counter == 3 )
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 1 ] = lastX;
		Mplat.platY[ 1 ] = lastY;
		Mplat.counter++;
	}
	if( Mplat.counter == 5)
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 2 ] = lastX;
		Mplat.platY[ 2 ] = lastY;
		Mplat.counter++;
	}
		if( Mplat.counter == 7)
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 3 ] = lastX;
		Mplat.platY[ 3 ] = lastY;
		Mplat.counter++;
	}
	if( Mplat.counter == 9)
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 4 ] = lastX;
		Mplat.platY[ 4 ] = lastY;
		Mplat.counter++;
	}
	if( Mplat.counter == 11)
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 5 ] = lastX;
		Mplat.platY[ 5 ] = lastY;
		Mplat.counter++;
	}
	if( Mplat.counter == 13)
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 6 ] = lastX;
		Mplat.platY[ 6 ] = lastY;
		Mplat.counter++;
	}
	if( Mplat.counter == 15)
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 7 ] = lastX;
		Mplat.platY[ 7 ] = lastY;
		Mplat.counter++;
	}
	if( Mplat.counter == 17)
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 8 ] = lastX;
		Mplat.platY[ 8 ] = lastY;
		Mplat.counter++;
	}
	if( Mplat.counter == 19)
	{
		lastX = cursorX;
		lastY = cursorY;
		Mplat.platX[ 9 ] = lastX;
		Mplat.platY[ 9 ] = lastY;
		Mplat.counter++;
	}
	
}
void Game::DrawRightPlatform()
{
	if( Rplat.counter == 1 )
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 0 ] = lastX;
		Rplat.platY[ 0 ] = lastY;
		Rplat.counter++;
	}
	if( Rplat.counter == 3 )
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 1 ] = lastX;
		Rplat.platY[ 1 ] = lastY;
		Rplat.counter++;
	}
	if( Rplat.counter == 5)
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 2 ] = lastX;
		Rplat.platY[ 2 ] = lastY;
		Rplat.counter++;
	}
		if( Rplat.counter == 7)
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 3 ] = lastX;
		Rplat.platY[ 3 ] = lastY;
		Rplat.counter++;
	}
	if( Rplat.counter == 9)
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 4 ] = lastX;
		Rplat.platY[ 4 ] = lastY;
		Rplat.counter++;
	}
	if( Rplat.counter == 11)
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 5 ] = lastX;
		Rplat.platY[ 5 ] = lastY;
		Rplat.counter++;
	}
	if( Rplat.counter == 13)
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 6 ] = lastX;
		Rplat.platY[ 6 ] = lastY;
		Rplat.counter++;
	}
	if( Rplat.counter == 15)
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 7 ] = lastX;
		Rplat.platY[ 7 ] = lastY;
		Rplat.counter++;
	}
	if( Rplat.counter == 17)
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 8 ] = lastX;
		Rplat.platY[ 8 ] = lastY;
		Rplat.counter++;
	}
	if( Rplat.counter == 19)
	{
		lastX = cursorX;
		lastY = cursorY;
		Rplat.platX[ 9 ] = lastX;
		Rplat.platY[ 9 ] = lastY;
		Rplat.counter++;
	}
	
}
void Game::UserFunctions()
{
	if( mouse.IsInWindow() )
	{
		cursorX = mouse.GetMouseX() - 25 + cameraX;
		cursorY = mouse.GetMouseY() - 25 +  cameraY;
		DragAndDropLogic();
	} 

	if( keyPressedLastFrame == false )
	{
		if( mouse.LeftIsPressed() )
		{
			if( DrawLeft == true )
			{
				Lplat.counter++;
			}

			if( DrawMiddle == true )
			{
				Mplat.counter++;
			}

			if( DrawRight == true )
			{
				Rplat.counter++;
			}
			
			keyPressedLastFrame = true;
		}
		else if( kbd.RightIsPressed() )
		{
			SelectorX += 64;

			if(SelectorX > 161)
			{
				SelectorX = 160;
			}

			keyPressedLastFrame = true;
		}
		else if( kbd.LeftIsPressed() )
		{
			SelectorX -= 64;

			if( SelectorX < 31 )
			{
				SelectorX = 32;
			}

			keyPressedLastFrame = true;
		}
		else
		{
			keyPressedLastFrame = false;
		}
	}
	if( !( mouse.LeftIsPressed() 
		|| kbd.RightIsPressed()
		|| kbd.LeftIsPressed() ) )
	{
		keyPressedLastFrame = false;
	}
}
void Game::DrawBackgroundClipped( int cameraX,int cameraY )
{
	// horizontal lines (rows)
	// we calculate the offset of the first row from the top of the
	// screen using cameraY % GRIDRESOLUTION, and then we just keep drawing rows every
	// GRIDRESOLUTION pixels until we reach the bottom of the screen
	for( int y = GRIDRESOLUTION - cameraY % GRIDRESOLUTION; y < SCREENHEIGHT; y += GRIDRESOLUTION )
	{
		gfx.DrawLine( 0,y,SCREENWIDTH-1,y,255,0,0 );
	}

	// vertical lines (columns)
	for( int x = GRIDRESOLUTION - cameraX % GRIDRESOLUTION; x < SCREENWIDTH; x += GRIDRESOLUTION )
	{
		gfx.DrawLine( x,0,x,SCREENHEIGHT-1,255,0,0 );
	}

	// world borders
	if( cameraY == 0 )
	{
		gfx.DrawLine( 0,0,SCREENWIDTH-1,0,0,255,0 );
	}
	if( cameraX == 0 )
	{
		gfx.DrawLine( 0,0,0,SCREENHEIGHT-1,0,255,0 );
	}
	if( cameraY == WORLDHEIGHT - SCREENHEIGHT )
	{
		gfx.DrawLine( 0,SCREENHEIGHT-1,SCREENWIDTH-1,SCREENHEIGHT-1,0,255,0 );
	}
	if( cameraX == WORLDWIDTH - SCREENWIDTH )
	{
		gfx.DrawLine( SCREENWIDTH-1,0,SCREENWIDTH-1,SCREENHEIGHT-1,0,255,0 );
	}
}
void Game::UpdateCamera()
{
	// convert face world coordinates to screen coordinates
	int cx = cursorX - cameraX;
	int cy = cursorY - cameraY;

	// scroll camera if face is out of tracking rectangle
	if( cx < CTRKOFFHOR )
	{
		cameraX = cursorX - CTRKOFFHOR ;
	}
	if( cx + 24 > SCREENWIDTH - CTRKOFFHOR )
	{
		cameraX = cursorX + 24 + CTRKOFFHOR - SCREENWIDTH;
	}
	if( cy < CTRKOFFVERT )
	{
		cameraY = cursorY - CTRKOFFVERT;
	}
	if( cy + 24 > SCREENHEIGHT - CTRKOFFVERT )
	{
		cameraY = cursorY + 24 + CTRKOFFVERT - SCREENHEIGHT;
	}

	// clamp camera so that the screen does not exceed
	// the edge of the world
	if( cameraX < 0 )
	{
		cameraX = 0;
	}
	else if( cameraX + SCREENWIDTH > WORLDWIDTH )
	{
		cameraX = WORLDWIDTH - SCREENWIDTH;
	}
	if( cameraY < 0 )
	{
		cameraY = 0;
	}
	else if( cameraY + SCREENHEIGHT > WORLDHEIGHT )
	{
		cameraY = WORLDHEIGHT - SCREENHEIGHT;
	}
}
void Game::DrawMenu()
{
	for(int y = 550; y < 600; y++ )
	{
		for( int x = 0; x < 800; x++)
		{
			gfx.PutPixel( x,y,192,192,192 );
		}
	}

	gfx.DrawBox( 32,555,0,0,0 );
	gfx.DrawBox( 96,555,0,0,0 );
	gfx.DrawBox( 160,555,0,0,0 );
	

	gfx.DrawSprite( 32,560,&platformL );
	gfx.DrawSprite( 100,560,&platformM );
	gfx.DrawSprite( 167,560,&platformR );
	
	gfx.DrawPlatformSelectBox(SelectorX,555,0,255,0);
}
void Game::MenuLogic()
{
	if( SelectorX == 32 )
	{
		DrawLeft = true;
		DrawMiddle = false;
		DrawRight = false;
	}
	if( SelectorX == 96 )
	{
		DrawMiddle = true;
		DrawLeft = false;
		DrawRight = false;
	}
	if( SelectorX == 160 )
	{
		DrawRight = true;
		DrawMiddle = false;
		DrawLeft = false;
	}

}
void Game::DragAndDropLogic()
{
	for( int index = 0; index < nPlats; index++ )
	{
		if( mouse.GetMouseX() > Lplat.platX[ index ] - cameraX
		 && mouse.GetMouseX() < Lplat.platX[ index ] + 32 - cameraX
		 && mouse.GetMouseY() > Lplat.platY[ index ] -cameraY
		 && mouse.GetMouseY() < Lplat.platY[ index ] + 32 - cameraY)
		{
			Lplat.drag = true;
			
			if( mouse.RightIsPressed() )
			{
				if( Lplat.drag == true )
				{
					Lplat.platX[ index ] = mouse.GetMouseX() - 20 + cameraX;
					Lplat.platY[ index ] = mouse.GetMouseY() - 15 + cameraY;
				}
			}
		 }
		else
		{
			Lplat.drag = false;
		}

		if( mouse.GetMouseX() > Mplat.platX[ index ] - cameraX
		 && mouse.GetMouseX() < Mplat.platX[ index ] + 32 - cameraX
		 && mouse.GetMouseY() > Mplat.platY[ index ] - cameraY
		 && mouse.GetMouseY() < Mplat.platY[ index ] + 32 - cameraY )
		{
			Mplat.drag = true;
			
			if( mouse.RightIsPressed() )
			{
				if( Mplat.drag == true )
					Lplat.drag = false;
					Rplat.drag = false;
				{
					Mplat.platX[ index ] = mouse.GetMouseX() - 20 + cameraX;
					Mplat.platY[ index ] = mouse.GetMouseY() - 15 + cameraY;
				}
			}
		}
		else
		{
			Mplat.drag = false;
		}

		if( mouse.GetMouseX() > Rplat.platX[ index ] - cameraX
		 && mouse.GetMouseX() < Rplat.platX[ index ] + 32 - cameraX
		 && mouse.GetMouseY() > Rplat.platY[ index ] - cameraY
		 && mouse.GetMouseY() < Rplat.platY[ index ] + 32 - cameraY ) 
		{
			Rplat.drag = true;
			
			if( mouse.RightIsPressed() )
			{
				if( Rplat.drag == true )
				{
					Rplat.platX[ index ] = mouse.GetMouseX() - 20 + cameraX;
					Rplat.platY[ index ] = mouse.GetMouseY() - 15 + cameraY;
				}
			}
		}
		else
		{
			Rplat.drag = false;
		}
	}
}
void Game::ComposeFrame()
{
	DrawBackgroundClipped( cameraX, cameraY );
	
	for( int index = 0; index < nPlats; index++ )
	{
		gfx.DrawSprite( Lplat.platX[ index ] - cameraX,Lplat.platY[ index ] - cameraY,&platformL );
		gfx.DrawSprite( Mplat.platX[ index ] - cameraX,Mplat.platY[ index ] - cameraY,&platformM );
		gfx.DrawSprite( Rplat.platX[ index] - cameraX,Rplat.platY[ index ] - cameraY,&platformR );
	}
	
	DrawMenu();


}
