
#pragma once

#include "D3DGraphics.h"
#include "Keyboard.h"
#include "Mouse.h"
#include "Sound.h"

#define WORLDWIDTH 1599
#define WORLDHEIGHT 1299

#define CTRKOFFVERT 70
#define CTRKOFFHOR 70
#define GRIDRESOLUTION 50

#define NPLATFORMS 30

class Game
{
	struct LeftPlatform
	{
		int platX[ NPLATFORMS ];
		int platY[ NPLATFORMS ];
		int counter;
		bool drag;

	};

	struct MidPlatform
	{
		int platX[ NPLATFORMS ];
		int platY[ NPLATFORMS ];
		int counter;
		bool drag;
	};
	
	struct RightPlatform
	{
		int platX[ NPLATFORMS ];
		int platY[ NPLATFORMS ];
		int counter;
		bool drag;
	};
	
public:
	Game( HWND hWnd,const KeyboardServer& kServer,const MouseServer& mServer );
	~Game();
	void Go();
private:
	void ComposeFrame();
	/********************************/
	/*  User Functions              */
	void UserFunctions();
	void DrawBackgroundClipped( int cameraX,int cameraY );
	void UpdateCamera();
	void DrawLeftPlatform();
	void DrawMiddlePlatform();
	void DrawRightPlatform();
	void DrawMenu();
	void MenuLogic();
	void DragAndDropLogic();
	/********************************/
private:
	D3DGraphics gfx;
	KeyboardClient kbd;
	MouseClient mouse;
	DSound audio;
	/********************************/
	/*  User Variables              */
	
	int cursorX;
	int cursorY;
	int cameraX;
	int cameraY;
	int lastX;
	int lastY;
	int nPlats;
	int SelectorX;
	
	bool keyPressedLastFrame;
	bool DrawLeft,DrawMiddle,DrawRight;
	
	LeftPlatform Lplat;
	MidPlatform Mplat;
	RightPlatform Rplat;

	Sprite platformL;
	Sprite platformM;
	Sprite platformR;

	/********************************/
};